#include "instance.h"

using namespace std;

instance ins;

pos drone_pos;

int dist2_wh(const order &a) {
  int r = 1000000000;
  for(int i = 0; i < ins.W; i++) {
    r = min(r, a.p.dist2(ins.wh[i].p));
  }
  return r;
}

int order_d(const order &o) {
  int d = 1000000000;
  bool ok = false;
  int poids = 0;
  int best = -1;
  for(auto item : o.ord) {
    poids += item.second*ins.weights[item.first];
  }
  for(int i = 0; i < ins.W; i++) {
    for(pair<int, int> item : o.ord) {
      if(ins.wh[i].disp[item.first] > 0) {
        ok = true;
        break;
      }
    }
    if(ok) {
      int d2 = drone_pos.dist2(ins.wh[i].p) + ins.wh[i].p.dist2(o.p);
      if(d2 < d) {
        d = d2;
        best = i;
      }
    }
  }
  if(poids > ins.max_load)
    d += ins.col*ins.col + ins.row*ins.row;
  for(int i = 0; i < ins.orders.size(); i++)
    if(ins.orders[i].id == o.id)
      ins.orders[i].best_wh = best;
  cerr << "okB" << endl;

  return d;
}

bool sort_ord(const order &a, const order &b) {
  // if(a.ord.size() == b.ord.size())
    return order_d(a) < order_d(b);
  // return a.ord.size() < b.ord.size();
}

int next(instance &ins) {
  int best = -1;
  for(int i = 0; i < ins.orders.size(); i++) {
    if(!ins.orders[i].ord.empty()) {
      best = i;
      break;
    }
  }
  return best;
}

class drone {
  public:
    drone(int id, pos p) : id(id), temps(0), p(p) {}
    int id;
    int temps;
    pos p;
    bool operator<(const drone &b) const {
      return temps > b.temps;
    }
};

void glouton(instance &ins) {
  int score = 0;
  priority_queue<drone> Q;

  for(int i = 0; i < ins.drones; i++)
    Q.push(drone(i, ins.wh[0].p));

  while(!Q.empty()) {
    drone dr = Q.top();
    Q.pop();

    drone_pos = dr.p;
    sort(ins.orders.begin(), ins.orders.end(), sort_ord);
    int next_i = next(ins);
    if(next_i < 0)
      break;
    order &ord = ins.orders[next_i];
    assert(!ord.ord.empty());
    pair<const int, int> &type = *ord.ord.begin();
    int quantity = min(type.second, ins.max_load/ins.weights[type.first]);
    // int wa = ins.find(dr.p, type.first, quantity); // TODO
    assert(ord.best_wh >= 0);
    int wa = ord.best_wh;
    quantity = min(quantity, ins.wh[wa].disp[type.first]);

    // augment drone_temps
    dr.temps += 1+ceil(sqrt(dr.p.dist2(ins.wh[wa].p)));
    dr.temps += 1+ceil(sqrt(ins.wh[wa].p.dist2(ord.p)));
    dr.p = ord.p;
    if(dr.temps > ins.T)
      continue;

    // optimiser l'ordre
    int load = quantity;
    vector<pair<int, int>> aprendre;
    aprendre.push_back(make_pair(type.first, quantity));
    for(pair<int, int> item : ord.ord) {
      if(load == ins.max_load)
        break;
      int q = min(item.second, ins.wh[wa].disp[item.first]);
      q = min(q, (ins.max_load-load)/ins.weights[item.first]);
      if(q > 0) {
        aprendre.push_back(make_pair(item.first, q));
        load += ceil(q*ins.weights[item.first]);
      }
    }

    // pass order
    for(pair<int, int> item : aprendre) {
    // decrease order / stock
      ins.wh[wa].disp[item.first] -= item.second;
      ord.ord[item.first] -= item.second;
      if(!ord.ord[item.first])
        ord.ord.erase(item.first);

      cout << dr.id << " L " << wa << " " << item.first << " " << item.second << endl;
    }
    for(pair<int, int> item : aprendre) {
      cout << dr.id << " D " << ord.id << " " << item.first << " " << item.second << endl;
    }

    // push again drone
    Q.push(dr);

    // compute score
    score += ceil(10.*(ins.T-dr.temps)/ins.T);
  }



  cerr << "Score : " << score << endl;
}

int main() {
  int seed = time(NULL);
  srand(seed);
  cerr << "seed : " << seed << endl;
  //instance ins;
  glouton(ins);
  return 0;
}
